import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;

import java.security.SecureRandom;
import java.text.DecimalFormat;
import java.util.*;



public class weatherReport {


		//Can be edited to change data dynamic, all non-zero positive values//////////////////////////////////////////
		private static int NUMBER_OF_RECORDS_TO_GENERATE = 5000;		//should be large	(00001 - 99999)				//
		private static int NUMBER_OF_STATION_IDS = 20;//(00001-99999) should be much less that records to generate	//
		private static int NUMBER_OF_ZIPCODES = 10;					//should be less than number of stations		//
		//////////////////////////////////////////////////////////////////////////////////////////////////////////////
		
		
		//Not to be edited////////////////////////////////////////////////////////////////////////////////////////////
		
		
		private static int number_of_secondary_dimensions = 1;		//StationID
		private static Random random = new Random();
		private static String[][] stationIDs = new String[NUMBER_OF_STATION_IDS][number_of_secondary_dimensions];
		private static String[] month = {"JAN", "FEB", "MAR", "APR", "MAY", "JUN", "JUL", "AUG", "SEP", "NOV", "DEC"};

		
		public static void main(String[] args) throws IOException
		{
			//create all of the stations
			generateStations();
			
			//output file
			File fileOut = new File("/home/cloudera/stationData/weatherReport_table"+ NUMBER_OF_RECORDS_TO_GENERATE + ".txt");
			BufferedWriter out = new BufferedWriter(new FileWriter(fileOut));
			
			//out.write("######    | #####   | -##.##### | -###.##### | -###.## | ##.### | #.##  | #### |  CCC  \n");
			  
	        //out.write(" Station ID | StationName | Temp   | Percip | Humid | Year | Month \n");
			//generate appropriate number of records
			for(int i = 1; i <= NUMBER_OF_RECORDS_TO_GENERATE; i++)
			{
				if(i == NUMBER_OF_RECORDS_TO_GENERATE)
					out.write(generateRecord());
				else
					out.write(generateRecord() + '\n');
				out.flush();
			}//end for
			out.close();
			System.out.println("Data output finished.");
			
			
			
		}//end main
		
		private static void generateStations() 
		{
			
			for(int i = 0; i < stationIDs.length; i++)
			{
				//create station IDs
				//out.write("######    | #####   | ##.##### | ###.##### | ###.## | ##.### | #.##  | #### |  CCC  \n");
				//out.write("StationID | Zipcode | Lat      | Lon  \n");
				//out.write("StationName | Temp   | Percip | Humid | Year | Month \n");
				
				
				//StationID: ######	00001		- 99999
				stationIDs[i][0] = formatStationID(i + 1);
				//Zipcode: #####	00001		- 99999
				
			}
			
		}

		public static String generateRecord()
		{
			int index = random.nextInt(NUMBER_OF_STATION_IDS);
			//out.write("StationID | Temp   | Percip | Humid | Year | Month \n");
			
			return 	stationIDs[index][0] + Character.toString((char) 1) + 												//StationID: ######	00001		- 99999
					formatTemp((-40.00000d) + (random.nextDouble()*(140.00d))) + Character.toString((char) 1) +		//Temp: ###.##		-40.00		- 140.00
					formatPercip(random.nextDouble()*(30.00d)) + Character.toString((char) 1) +						//Percip: ##.###	00.000 		- 30.000
					formatHumid(random.nextDouble()) + Character.toString((char) 1) +									//Humid: #.##		0.00 		- 1.00
					formatYear(1900 + random.nextInt(110)) + Character.toString((char) 1) +							//Year: ####		1900		- 2010
					formatMonth(random.nextInt(11));			
		}
			
		
	
		

		public static String formatStationID(int value)
		{
			DecimalFormat df = new DecimalFormat("#000000");
			return df.format(value);
		}
		
		
		public static String formatTemp(double value)
		{
			DecimalFormat df = new DecimalFormat("#000.00");
			if(value < 0)
				return df.format(value);
			else
				return df.format(value);
		}
		
		public static String formatPercip(double value)
		{
			DecimalFormat df = new DecimalFormat("#00.000");
			return df.format(value);
		}
		
		public static String formatHumid(double value)
		{
			DecimalFormat df = new DecimalFormat("#0.00");
			return df.format(value);
		}
		
		private static String formatMonth(int value) {
			return month[value];
		}

		private static String formatYear(int value) {
			return value+"";
		}
		
		
	}
	
	


	
	
