import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.math.BigInteger;
import java.security.SecureRandom;
import java.text.DecimalFormat;
import java.util.*;



public class GenerateWeatherStationData {

	
	

	//Can be edited to change data dynamic, all non-zero positive values//////////////////////////////////////////
	private static int NUMBER_OF_STATION_IDS = 20;//(00001-99999) should be much less that records to generate	//
	private static int NUMBER_OF_ZIPCODES = 10;					//should be less than number of stations		//
	//////////////////////////////////////////////////////////////////////////////////////////////////////////////
	
	
	//Not to be edited////////////////////////////////////////////////////////////////////////////////////////////
	
	
	private static int number_of_secondary_dimensions = 5;		//StationID, Zip, latitude, longitude, name
	private static Random random = new Random();
	private static String[][] stationIDs = new String[NUMBER_OF_STATION_IDS][number_of_secondary_dimensions];
	private static String[] month = {"JAN", "FEB", "MAR", "APR", "MAY", "JUN", "JUL", "AUG", "SEP", "NOV", "DEC"};
	
	
	public static void main(String[] args) throws IOException
	{
		//create all of the stations
		generateStations();
		
		//output file
		File fileOut = new File("/home/cloudera/stationData/station_table"+ NUMBER_OF_STATION_IDS + ".txt");
		BufferedWriter out = new BufferedWriter(new FileWriter(fileOut));
		
		
		//out.write("StationID | StationName | Zipcode |     latitude      |   Lon   | Name");
          
		//generate appropriate number of records
		for(int i = 0; i < NUMBER_OF_STATION_IDS; i++)
		{
			if(i == (NUMBER_OF_STATION_IDS-1))
				out.write(generateRecord(i));
			else
				out.write(generateRecord(i) + '\n');
			out.flush();
		}//end for
		out.close();
		System.out.println("Data output finished.");
		
		
		
	}//end main
	
	public static String generateRecord(int index)
	{
		
		
		
		return 	stationIDs[index][0] + Character.toString((char) 1) +												
				stationIDs[index][1] + Character.toString((char) 1)	+							
				stationIDs[index][2] + Character.toString((char) 1)	+											
				stationIDs[index][3] + Character.toString((char) 1) +											
				stationIDs[index][4] ;											
				
	}
		
		
	private static void generateStations() 
	{
		
		for(int i = 0; i < stationIDs.length; i++)
		{
			
			
			
			
			//StationID: ######	00001		- 99999
			stationIDs[i][0] = formatStationID(i + 1);
			//Zipcode: #####	00001		- 99999
			stationIDs[i][4] = "Station " + (i+1);
			stationIDs[i][1] = formatZipcode(random.nextInt(NUMBER_OF_ZIPCODES) + 1);			
			//latitude: ##.#####		-90.00000	- 90.00000
			stationIDs[i][2] = formatlatitude((-90.00d) + (random.nextDouble()*(180.00d)));
			//Lon: ###.#####	-179.99999	- 180.00000
			stationIDs[i][3] = formatLon((-180.00000d) + (random.nextDouble()*(360.00d)));
			//Name: ##########
			
		}
	}



	public static String formatStationID(int value)
	{
		DecimalFormat df = new DecimalFormat("#000000");
		return df.format(value);
	}
	
	public static String formatZipcode(int value)
	{
		DecimalFormat df = new DecimalFormat("#00000");
		return df.format(value);
	}
	
	public static String formatlatitude(double value)
	{
		DecimalFormat df = new DecimalFormat("#00.00000");
		if(value < 0)
			return df.format(value);
		else
			return df.format(value);
	}
	
	public static String formatLon(double value)
	{
		DecimalFormat df = new DecimalFormat("#000.00000");
		if(value < 0)
			return df.format(value);
		else
			return df.format(value);
	}
	


	
}





